unit vektory_f;

interface

uses
    Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
    Dialogs, Grids, StdCtrls;

type
    Tfrmvektor = class(TForm)
      grdPole: TStringGrid;
      btnKonec: TButton;
      Label1: TLabel;
      Label2: TLabel;
      Label3: TLabel;
      edtIndex: TEdit;
      edtHodnota: TEdit;
      Label4: TLabel;
      lblVysledek: TLabel;
      btnNahodne: TButton;
      btnJednotlive: TButton;
      btnZeSouboru: TButton;
      Label5: TLabel;
      btnJakoText: TButton;
      btnDoMrizky: TButton;
      btnDosouboru: TButton;
      btnNulovat: TButton;
      Label6: TLabel;
      edtVelikost: TEdit;
      Label7: TLabel;
      Label8: TLabel;
      edtMinh: TEdit;
      edtMaxh: TEdit;
      Label9: TLabel;
      btnMin: TButton;
      btnMax: TButton;
      btnPrumer: TButton;
      btnSeradit: TButton;
      sdiaUlozit: TSaveDialog;
      sdiaPrecist: TOpenDialog;
    procedure btnNahodneClick(Sender: TObject);
    procedure btnDoMrizkyClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnMinClick(Sender: TObject);
    private
      { Private declarations }
    public
      { Public declarations }
    end;

var
    frmvektor: Tfrmvektor;

implementation

{$R *.dfm}

CONST
  max = 10;
type
  TPole = ARRAY[1..MAX] of integer;
VAR
  pole : tpole;
  n : integer;//aktualni rozmer pole

// aplikan podprogramy

procedure NahodnePole(MinH, MaxH, n: integer;VAR pole:TPole);
var
  I: Integer;
begin
  for I := 1 to n do
    pole[i]:= MinH + Random(maxH - MinH +1);
end;

procedure ZobrazitPoleDoMrizky(n: integer;VAR pole:TPole);
var
  I: Integer;
begin
  for I := 1 to n do
    frmvektor.grdpole.cells[i-1,0]:= intToStr(pole[i]);

end;

function MinimumVPoli(n :integer;var pole :Tpole; var IndM: integer): Integer;
var
  minH, I : integer;
begin
  minH := pole[1];
  indM := 1;
  for I := 2 to n do begin
    if minH > pole[i] then begin
      minH := pole[i];
      indM := i;
    end;
  end;
  MinimumVPoli:=minH;
end;

procedure Tfrmvektor.btnDoMrizkyClick(Sender: TObject);
begin
  self.grdPole.ColCount := n;
  ZobrazitPoleDoMrizky(n,Pole);
end;

procedure Tfrmvektor.btnMinClick(Sender: TObject);
var
  min,IndM : integer;
begin
  min:=MinimumVPoli(n,pole,IndM);
  self.edtHodnota.Text := IntToStr(min);
  self.edtIndex.Text := IntToStr(IndM);

end;

procedure Tfrmvektor.btnNahodneClick(Sender: TObject);
var
  MinH,MaxH:integer;
begin
  n:= strToInt(self.edtVelikost.text);
  MinH := strToInt(self.edtMinh.text);
  MaxH := strToInt(self.edtMaxh.text);
  NahodnePole(MinH, MaxH, n, pole);
end;

procedure Tfrmvektor.FormActivate(Sender: TObject);
begin
  randomize;
end;

end.
